<template>
    <div class="container">
        <div class="head">
            <img class="goback" :src="goback"  @click="onClickLeft" alt="">
            <img class="logo" :src="logo" alt="">
        </div>
        <div class="main">
            <div class="title">欢迎回来</div>
            <div class="form">
                <div class="mes">
                    <input type="text" placeholder="请输入您的用户名或手机号" v-model="userName">
                </div>
                <div class="mes" style="margin-bottom:15px;">
                    <input type="password" placeholder="请输入您的密码" v-model="password">
                </div>
                <div class="code" >
                    <div class="mes" style="flex:1; margin-bottom:17px; margin-right: 14px;">
                        <input type="text" placeholder="请输入验证码" v-model="code">
                    </div>
                  <div class="mes" @click="refreshCode" style="overflow:hidden; width: 105px; margin-bottom:17px;;display: flex;justify-content: center;align-items: center" ref="codeMes">
                    <SIdentify :identifyCode="identifyCode" @click="refreshCode"/>
                  </div>
                </div>
                <div class="btn" @click="login()">登 录</div>
            </div>
        </div>
    </div>
</template>

<script>
import logo from '@/assets/logo.png'
import goback from '@/assets/detail/goback_first.png'
import { Toast } from 'vant'
import SIdentify from '@/views/Identify'
// import axios from 'axios'
export default {
  name: 'Login',
  data () {
    return {
      logo,
      goback,
      userName: '',
      password: '',
      code: '',
      mes: '',
      identifyCodes: '1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ',
      identifyCode: '',
      userId: '',
      path: 'ws://121.199.79.177:10201/message/api/',
      socket: ''
    }
  },
  computed: {
  },
  mounted () {
    this.identifyCode = ''
    this.makeCode(this.identifyCodes, 4)
  },
  methods: {
    init: function () {
      if (typeof WebSocket === 'undefined') {
        alert('您的浏览器不支持socket')
      } else {
        // 实例化socket
        this.userId = this.$store.state.userInfo.detail.userId
        this.socket = new WebSocket(this.path + this.userId)
        // 监听socket连接
        this.socket.onopen = this.open
        // 监听socket错误信息
        this.socket.onerror = this.error
        // 监听socket消息
        this.socket.onmessage = this.getMessage
      }
    },
    open: function () {
      console.info('[Socket Local] 连接成功')
    },
    error: function () {
      console.error('[Socket Local] 连接错误')
    },
    getMessage: function (msg) {
      console.log(msg.data)
    },
    send: function () {
      this.socket.send(this.userId)
    },
    close: function () {
      this.socket.close()
      console.info('[Socket Local] 连接关闭')
    },
    refreshCode () {
      this.identifyCode = ''
      this.makeCode(this.identifyCodes, 4)
    },
    makeCode (o, l) {
      let randomNum = (min, max) => Math.floor((max - min) * Math.random() + min)
      for (let i = 0; i < l; i++) {
        let randomCh = this.identifyCodes[randomNum(0, this.identifyCodes.length)]
        this.identifyCode += randomCh
      }
      console.log(this.identifyCode)
    },
    onClickLeft () {
      this.$router.push('/first')
    },
    login: async function () {
      if (!this.userName) {
        Toast('请输入您的用户名或手机号')
        return
      }
      if (!this.password) {
        Toast('请输入您的密码')
        return
      }
      if (!this.code) {
        Toast('请输入验证码')
        return
      }
      if (this.code.toLowerCase() !== this.identifyCode.toLowerCase()) {
        console.log(this.identifyCode)
        Toast('验证码错误')
        return
      }
      if (this.userName.length > 18) {
        Toast('用户名长度不应超过18个字符')
        return
      }
      if (this.password.length > 30) {
        Toast('密码长度不应超过30个字符')
        return
      }
      this.$api.login(this.userName, this.password)
        .then(res => {
          console.log(res.data.data)
          if (res.data.code === 200) {
            Toast('登录成功')
            this.$router.push('/index')
            console.log(res.data.data.id)
            localStorage.setItem('userId', res.data.data.id)
            return this.$api.myInfo()
          } else {
            Toast(res.data.message)
          }
          return this.$api.myInfo()
        }).then(res => {
          this.$store.commit('userInfo/setUserInfo', res.data.data)
          console.log(this.$store.state.userInfo.detail.userId)
        }).catch(() => {
        })
    }
  },
  components: {
    SIdentify: SIdentify
  }
}
</script>
<style scoped lang="less">
    .container{
        background: #3170ff;
        display: flex;
        flex-direction: column;
        .head{
          .goback{
            width:20px;
            height:16px;
            position: fixed;
            top:16px;
            left:14px;
          }
            .logo{
                padding:29.5px 40.4% 24.5px 43.1%;
                width: 62px;
                height:76.5px;
            }
        }
        .main{
            background: #fff;
            border-top-left-radius: 45px;
            border-top-right-radius: 45px;
            .title{
                padding-top: 50px;
                font-size: 17px;
                font-weight: bold;
                color:#285ed8;
                text-align: center;
                letter-spacing:7.25px;
                text-indent: 7.25px;
            }
            .form{
                padding: 65px 15.6% 0 16.9%;
                .mes{
                    display:flex;
                    align-items: center;
                    border-radius: 4px;
                    border:1px solid #dcdcdc;
                    height:37.5px;
                    margin-bottom: 13.5px;
                    input{
                        padding-left:14.5px;
                        font-size: 13px;
                        color: #a8a8a8;
                        font-weight:lighter;
                        letter-spacing: 1.5px;
                        width: 100%;
                        border:none;
                        outline:none;
                    }
                    input::-webkit-input-placeholder{
                        color: #a8a8a8;
                    }
                }
                .code{
                    display: flex;
                    justify-content: space-between;
                    div{
                        width: 45%;
                    }
                    img{
                    }
                }
                /deep/.s-canvas{
                  width:126px;
                  height:37.5px;
                  display: flex;
                  justify-content: center;
                  align-items: center;
                }
                .btn{
                    display:flex;
                    align-items: center;
                    justify-content: center;
                    height:32.5px;
                    font-size: 14.9px;
                    font-weight: bold;
                    background:#3170ff;
                    color: #fff;
                    border-radius: 4px;
                    letter-spacing:12.6px;
                    text-indent: 12.6px;
                }
            }
        }
    }
</style>
